<template>
  <v-data-table
    :headers="headers"
    :items="products"
    :loading="loading"
    :footer-props="{
      showCurrentPage: true,
      showFirstLastPage: true,
      itemsPerPageOptions: [20, 50, 100]
    }"
    :server-items-length="totalProducts"
    :options.sync="options"
    @update:options="updateFilter"
    class="elevation-1"
  ></v-data-table>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { LOADING } from '../../store/statuses';

const { mapState, mapActions } = createNamespacedHelpers('catalog');

export default {
  name: "ProductsTable",
  data () {
    return {
      headers: [
        { text: 'Название', value: 'attributes.name' },
        { text: 'Описание', value: 'attributes.description' },
        { text: 'Вес', value: 'attributes.weight' },
        { text: 'Категория', value: 'attributes.category' },
      ],
      filterLocal: {},
      sortBy: {},
      options: {},
    }
  },
  computed: {
    ...mapState({
      filter: state => state.Product.filter,
      products: state => state.Product.items,
      totalProducts: state => state.Product.totalItems,
      loading: state => state.Product.status === LOADING,
    }),
  },
  watch: {
    filter() {
      this.loadProducts();
    }
  },
  methods: {
    ...mapActions(["setProductsFilter", "loadProducts"]),
    updateFilter() {
      this.filterLocal = {
        ...this.filter,
        ...{
          page: this.options.page,
          itemsPerPage: this.options.itemsPerPage,
        }
      };

      for (let key in this.sortBy) {
        this.sortBy[key] = '';
      }

      if (this.options.sortBy.length) {
        this.sortBy = {
          [`order[${this.options.sortBy[0].replace('attributes.', '')}]`]: this.options
            .sortDesc[0]
            ? 'desc'
            : 'asc'
        }
      }

      this.setProductsFilter({ ...this.filterLocal, ...this.sortBy });
    },
  },
  mounted() {
    this.updateFilter();
  }
}
</script>
